/*****************************************************************************
Win32 "hello" program using AS, LD, and LIBKERNEL32.A
AS.EXE, LD.EXE, and LIBKERNEL32.A are part of MinGW
*****************************************************************************/

STD_OUTPUT_HANDLE = -11

.SECTION .text

/* these are in LIBKERNEL32.A */
.EXTERN	_GetStdHandle@4, _WriteConsoleA@20, _ExitProcess@4

.GLOBAL start
start:
	pushl $0
	pushl $num_written
	pushl $msg_len
	pushl $hello
	pushl $STD_OUTPUT_HANDLE
	call _GetStdHandle@4

	pushl %eax
	call _WriteConsoleA@20

	pushl $0
	call _ExitProcess@4

.SECTION .data
hello:
	.ascii "Hello world!"
	.byte 13, 10
msg_len = .-hello

.SECTION .bss
num_written:
	.long 0
