;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Win32 "hello" program using NASM, LD, and LIBKERNEL32.A
; LD.EXE and LIBKERNEL32.A are part of MinGW
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

STD_OUTPUT_HANDLE	equ	-11

SECTION .text

; these are in LIBKERNEL32.A:
EXTERN	_GetStdHandle@4, _WriteConsoleA@20, _ExitProcess@4

GLOBAL start
start:
	push 0
	push num_written
	push msg_len
	push hello
	push STD_OUTPUT_HANDLE
	call _GetStdHandle@4

	push eax
	call _WriteConsoleA@20

	push 0
	call _ExitProcess@4

SECTION .data
hello:
	db "Hello world!", 10
msg_len equ $-hello

SECTION .bss
num_written:
	resd 1
