;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Win32 "hello" program using NASM, ILINK32, and IMPORT32.LIB
; ILINK32 and IMPORT32.LIB are part of Borland C++ 5.5
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SEGMENT _TEXT PUBLIC USE32
SEGMENT _DATA PUBLIC USE32
SEGMENT BSS   PUBLIC USE32

GROUP DGROUP _DATA BSS

STD_OUTPUT_HANDLE	equ	-11

; these are in IMPORT32.LIB:
EXTERN	GetStdHandle, WriteConsoleA, ExitProcess

SEGMENT _TEXT
..start:
	push 0
	push num_written
	push msg_len
	push hello
	push STD_OUTPUT_HANDLE
	call GetStdHandle

	push eax
	call WriteConsoleA

	push 0
	call ExitProcess

SEGMENT _DATA
hello:
	db "Hello world!", 10
msg_len equ $-hello

SEGMENT BSS
num_written:
	resd 1
